import{s as ze,n as Ae,o as Ke}from"../chunks/scheduler.362310b7.js";import{S as We,i as Ze,g as i,s as n,r as c,A as Re,h as r,f as a,c as s,j as He,u as o,x as p,k as Ue,y as Se,a as l,v as m,d as f,t as u,w as h}from"../chunks/index.57dfc70d.js";import{C as ve}from"../chunks/CodeBlock.d3c47f83.js";import{H as W,E as qe}from"../chunks/EditOnGithub.9633c464.js";function Be(Ce){let $,S,Z,q,w,B,d,xe="Text Generation Inference (TGI) now supports FP8 KV Cache, enhancing inference speed on both Nvidia and AMD GPUs. This feature significantly boosts performance and memory efficiency, enabling faster and more scalable text generation. By quantizing the KV cache to 8-bit floating point (FP8) formats, we can greatly reduce the memory footprint. This reduction allows for improved throughput in text generation tasks",N,g,D,T,be="The Open Compute Project (OCP) defines two common 8-bit floating point data formats:",Y,v,Pe="E4M3:",O,C,Ie="<li>1 sign bit</li> <li>4 biased exponent bits</li> <li>3 mantissa bits</li>",X,x,Me="E5M2:",Q,b,Je="<li>1 sign bit</li> <li>5 biased exponent bits</li> <li>2 mantissa bits</li>",ee,P,_e="E4M3 offers higher precision for representing floating point numbers. However, due to its limited range, E4M3 typically requires a higher-precision (usually FP32) scaling factor alongside each quantized tensor. Currently, TGI supports only per-tensor (scalar) scaling factors.",te,I,ae,M,ye="<li>Nvidia GPUs:  Supports both FP8E4M3 and FP8E5M2.</li> <li>AMD GPUs: Supports FP8E4M3.</li>",le,J,ne,_,Fe="Example usage:",se,y,ie,F,re,k,ke="While E4M3 offers higher precision, it requires careful handling of scaling factors to maintain accuracy. Therefore, it is recommended to provide KV cache scaling factors as part of the FP16 checkpoint. If scaling factors are not provided, a default factor of 1.0 is used, which may lead to accuracy loss.",pe,j,je="Example usage:",ce,E,oe,L,me,V,Ee="The FP8 kv cache scaling factors required in the FP16 checkpoints are specified through the .kv_scale parameter present on the <code>Attention</code> module, such as:",fe,G,ue,H,he,U,Le='Use <a href="https://github.com/neuralmagic/AutoFP8" rel="nofollow">AutoFP8</a> with calibration data to generate per-tensor scales for FP8 quantized KV Cache. For more details, see the following example: <a href="https://github.com/neuralmagic/AutoFP8/blob/main/example_dataset.py" rel="nofollow">https://github.com/neuralmagic/AutoFP8/blob/main/example_dataset.py</a>',$e,z,Ve="TGI provides a utility to extract the FP8 KV cache scales from an <code>AutoFP8</code> quantized model and save them to the FP16 model for use with TGI. For more information: &lt;path to script&gt;",we,A,Ge="Alternatively, you can use other quantizer tools, such as Nvidia AMMO, to obtain these scaling factors.",de,K,ge,R,Te;return w=new W({props:{title:"Accelerating Inference with FP8 KV Cache",local:"accelerating-inference-with-fp8-kv-cache",headingTag:"h1"}}),g=new W({props:{title:"FP8 Formats: E4M3 and E5M2",local:"fp8-formats-e4m3-and-e5m2",headingTag:"h2"}}),I=new W({props:{title:"Current Hardware Support",local:"current-hardware-support",headingTag:"h2"}}),J=new W({props:{title:"FP8 E5M2 KV Cache",local:"fp8-e5m2-kv-cache",headingTag:"h2"}}),y=new ve({props:{code:"dGV4dC1nZW5lcmF0aW9uLWxhdW5jaGVyJTIwLS1tb2RlbC1pZCUyMCUzQyUzRSUyMC0ta3YtY2FjaGUtZHR5cGUlMjBmcDhfZTVtMg==",highlighted:'text-generation-launcher <span class="hljs-attr">--model-id</span> &lt;&gt; <span class="hljs-attr">--kv-cache-dtype</span> fp8_e5m2',wrap:!1}}),F=new W({props:{title:"FP8 E4M3 KV Cache",local:"fp8-e4m3-kv-cache",headingTag:"h2"}}),E=new ve({props:{code:"dGV4dC1nZW5lcmF0aW9uLWxhdW5jaGVyJTIwLS1tb2RlbC1pZCUyMCUzQyUzRSUyMC0ta3YtY2FjaGUtZHR5cGUlMjBmcDg=",highlighted:'text-generation-launcher <span class="hljs-attr">--model-id</span> &lt;&gt; <span class="hljs-attr">--kv-cache-dtype</span> fp8',wrap:!1}}),L=new W({props:{title:"Checkpoint structure for KV scales",local:"checkpoint-structure-for-kv-scales",headingTag:"h3"}}),G=new ve({props:{code:"bW9kZWwubGF5ZXJzLjAuc2VsZl9hdHRuLmt2X3NjYWxlJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTNDJTIwRjMyJTBBbW9kZWwubGF5ZXJzLjEuc2VsZl9hdHRuLmt2X3NjYWxlJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTIwJTNDJTIwRjMyJTBBLi4u",highlighted:`model<span class="hljs-selector-class">.layers</span>.<span class="hljs-number">0</span><span class="hljs-selector-class">.self_attn</span><span class="hljs-selector-class">.kv_scale</span>                &lt; F32
model<span class="hljs-selector-class">.layers</span>.<span class="hljs-number">1</span><span class="hljs-selector-class">.self_attn</span><span class="hljs-selector-class">.kv_scale</span>                &lt; F32
...`,wrap:!1}}),H=new W({props:{title:"Generating model with KV Cache scales",local:"generating-model-with-kv-cache-scales",headingTag:"h3"}}),K=new qe({props:{source:"https://github.com/huggingface/text-generation-inference/blob/main/docs/source/basic_tutorials/fp8_kv_cache.md"}}),{c(){$=i("meta"),S=n(),Z=i("p"),q=n(),c(w.$$.fragment),B=n(),d=i("p"),d.textContent=xe,N=n(),c(g.$$.fragment),D=n(),T=i("p"),T.textContent=be,Y=n(),v=i("p"),v.textContent=Pe,O=n(),C=i("ul"),C.innerHTML=Ie,X=n(),x=i("p"),x.textContent=Me,Q=n(),b=i("ul"),b.innerHTML=Je,ee=n(),P=i("p"),P.textContent=_e,te=n(),c(I.$$.fragment),ae=n(),M=i("ul"),M.innerHTML=ye,le=n(),c(J.$$.fragment),ne=n(),_=i("p"),_.textContent=Fe,se=n(),c(y.$$.fragment),ie=n(),c(F.$$.fragment),re=n(),k=i("p"),k.textContent=ke,pe=n(),j=i("p"),j.textContent=je,ce=n(),c(E.$$.fragment),oe=n(),c(L.$$.fragment),me=n(),V=i("p"),V.innerHTML=Ee,fe=n(),c(G.$$.fragment),ue=n(),c(H.$$.fragment),he=n(),U=i("p"),U.innerHTML=Le,$e=n(),z=i("p"),z.innerHTML=Ve,we=n(),A=i("p"),A.textContent=Ge,de=n(),c(K.$$.fragment),ge=n(),R=i("p"),this.h()},l(e){const t=Re("svelte-u9bgzb",document.head);$=r(t,"META",{name:!0,content:!0}),t.forEach(a),S=s(e),Z=r(e,"P",{}),He(Z).forEach(a),q=s(e),o(w.$$.fragment,e),B=s(e),d=r(e,"P",{"data-svelte-h":!0}),p(d)!=="svelte-1m6znvc"&&(d.textContent=xe),N=s(e),o(g.$$.fragment,e),D=s(e),T=r(e,"P",{"data-svelte-h":!0}),p(T)!=="svelte-k2vmhj"&&(T.textContent=be),Y=s(e),v=r(e,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1nej14h"&&(v.textContent=Pe),O=s(e),C=r(e,"UL",{"data-svelte-h":!0}),p(C)!=="svelte-166b2xq"&&(C.innerHTML=Ie),X=s(e),x=r(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-19rwy65"&&(x.textContent=Me),Q=s(e),b=r(e,"UL",{"data-svelte-h":!0}),p(b)!=="svelte-yfzin2"&&(b.innerHTML=Je),ee=s(e),P=r(e,"P",{"data-svelte-h":!0}),p(P)!=="svelte-1j4wme8"&&(P.textContent=_e),te=s(e),o(I.$$.fragment,e),ae=s(e),M=r(e,"UL",{"data-svelte-h":!0}),p(M)!=="svelte-39ydx8"&&(M.innerHTML=ye),le=s(e),o(J.$$.fragment,e),ne=s(e),_=r(e,"P",{"data-svelte-h":!0}),p(_)!=="svelte-1ni337v"&&(_.textContent=Fe),se=s(e),o(y.$$.fragment,e),ie=s(e),o(F.$$.fragment,e),re=s(e),k=r(e,"P",{"data-svelte-h":!0}),p(k)!=="svelte-11axo0a"&&(k.textContent=ke),pe=s(e),j=r(e,"P",{"data-svelte-h":!0}),p(j)!=="svelte-1ni337v"&&(j.textContent=je),ce=s(e),o(E.$$.fragment,e),oe=s(e),o(L.$$.fragment,e),me=s(e),V=r(e,"P",{"data-svelte-h":!0}),p(V)!=="svelte-x865bk"&&(V.innerHTML=Ee),fe=s(e),o(G.$$.fragment,e),ue=s(e),o(H.$$.fragment,e),he=s(e),U=r(e,"P",{"data-svelte-h":!0}),p(U)!=="svelte-ethkow"&&(U.innerHTML=Le),$e=s(e),z=r(e,"P",{"data-svelte-h":!0}),p(z)!=="svelte-1u2z6lc"&&(z.innerHTML=Ve),we=s(e),A=r(e,"P",{"data-svelte-h":!0}),p(A)!=="svelte-120zcw0"&&(A.textContent=Ge),de=s(e),o(K.$$.fragment,e),ge=s(e),R=r(e,"P",{}),He(R).forEach(a),this.h()},h(){Ue($,"name","hf:doc:metadata"),Ue($,"content",Ne)},m(e,t){Se(document.head,$),l(e,S,t),l(e,Z,t),l(e,q,t),m(w,e,t),l(e,B,t),l(e,d,t),l(e,N,t),m(g,e,t),l(e,D,t),l(e,T,t),l(e,Y,t),l(e,v,t),l(e,O,t),l(e,C,t),l(e,X,t),l(e,x,t),l(e,Q,t),l(e,b,t),l(e,ee,t),l(e,P,t),l(e,te,t),m(I,e,t),l(e,ae,t),l(e,M,t),l(e,le,t),m(J,e,t),l(e,ne,t),l(e,_,t),l(e,se,t),m(y,e,t),l(e,ie,t),m(F,e,t),l(e,re,t),l(e,k,t),l(e,pe,t),l(e,j,t),l(e,ce,t),m(E,e,t),l(e,oe,t),m(L,e,t),l(e,me,t),l(e,V,t),l(e,fe,t),m(G,e,t),l(e,ue,t),m(H,e,t),l(e,he,t),l(e,U,t),l(e,$e,t),l(e,z,t),l(e,we,t),l(e,A,t),l(e,de,t),m(K,e,t),l(e,ge,t),l(e,R,t),Te=!0},p:Ae,i(e){Te||(f(w.$$.fragment,e),f(g.$$.fragment,e),f(I.$$.fragment,e),f(J.$$.fragment,e),f(y.$$.fragment,e),f(F.$$.fragment,e),f(E.$$.fragment,e),f(L.$$.fragment,e),f(G.$$.fragment,e),f(H.$$.fragment,e),f(K.$$.fragment,e),Te=!0)},o(e){u(w.$$.fragment,e),u(g.$$.fragment,e),u(I.$$.fragment,e),u(J.$$.fragment,e),u(y.$$.fragment,e),u(F.$$.fragment,e),u(E.$$.fragment,e),u(L.$$.fragment,e),u(G.$$.fragment,e),u(H.$$.fragment,e),u(K.$$.fragment,e),Te=!1},d(e){e&&(a(S),a(Z),a(q),a(B),a(d),a(N),a(D),a(T),a(Y),a(v),a(O),a(C),a(X),a(x),a(Q),a(b),a(ee),a(P),a(te),a(ae),a(M),a(le),a(ne),a(_),a(se),a(ie),a(re),a(k),a(pe),a(j),a(ce),a(oe),a(me),a(V),a(fe),a(ue),a(he),a(U),a($e),a(z),a(we),a(A),a(de),a(ge),a(R)),a($),h(w,e),h(g,e),h(I,e),h(J,e),h(y,e),h(F,e),h(E,e),h(L,e),h(G,e),h(H,e),h(K,e)}}}const Ne='{"title":"Accelerating Inference with FP8 KV Cache","local":"accelerating-inference-with-fp8-kv-cache","sections":[{"title":"FP8 Formats: E4M3 and E5M2","local":"fp8-formats-e4m3-and-e5m2","sections":[],"depth":2},{"title":"Current Hardware Support","local":"current-hardware-support","sections":[],"depth":2},{"title":"FP8 E5M2 KV Cache","local":"fp8-e5m2-kv-cache","sections":[],"depth":2},{"title":"FP8 E4M3 KV Cache","local":"fp8-e4m3-kv-cache","sections":[{"title":"Checkpoint structure for KV scales","local":"checkpoint-structure-for-kv-scales","sections":[],"depth":3},{"title":"Generating model with KV Cache scales","local":"generating-model-with-kv-cache-scales","sections":[],"depth":3}],"depth":2}],"depth":1}';function De(Ce){return Ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends We{constructor($){super(),Ze(this,$,De,Be,ze,{})}}export{et as component};
